-- Give the player an item
COM_AddCommand("mc_give", function(player, type, amount)
	if type != nil then
		type = string.upper(type)
		if string.sub(type, 1, 3) != "MT_" then
			type = "MT_" .. type
		end
	end
	
	if not stevehelper.validinfo(player) then
		CONS_Printf(player, "This command can only be used while playing as Steve.")
		return
	elseif type == nil or not pcall(function() return _G[type] end) then
		CONS_Printf(player, "mc_give <objtype> [<amount>]: give yourself an item")
		return
	end
	
	for i = 1, (amount == nil and 1 or max(1, amount)) do
		stevehelper.giveitem(player, _G[type])
	end
end, COM_ADMIN)

-- Clear the player's hotbar
COM_AddCommand("mc_clear", function(player)
	if not stevehelper.validinfo(player) then
		CONS_Printf(player, "This command can only be used while playing as Steve.")
		return
	end
	stevehelper.clearhotbar(player)
end, COM_ADMIN)

-- Restore the player's health
COM_AddCommand("mc_heal", function(player)
	if not stevehelper.validinfo(player) then
		CONS_Printf(player, "This command can only be used while playing as Steve.")
		return
	end
	player.steve.persist.health = 20
	player.steve.play.regentimer = 20
end, COM_ADMIN)

-- Back up the hotbar
COM_AddCommand("mc_backup", function(player)
	if not stevehelper.validinfo(player) then
		CONS_Printf(player, "This command can only be used while playing as Steve.")
		return
	end
	stevehelper.backuphotbar(player)
end, COM_ADMIN)

-- Restore the hotbar from backup
COM_AddCommand("mc_restore", function(player)
	if not stevehelper.validinfo(player) then
		CONS_Printf(player, "This command can only be used while playing as Steve.")
		return
	end
	stevehelper.restorehotbar(player)
end, COM_ADMIN)

-- Shift the selected hotbar slot a certain number of places
-- (This command exists only to sync the hotbar slot in netgames)
COM_AddCommand("mc_shiftslot", function(player, amount)
	if not stevehelper.validinfo(player) then
		CONS_Printf(player, "This command can only be used while playing as Steve.")
		return
	end
	amount = tonumber($)
	if amount == nil or amount < -8 or amount > 8 then
		CONS_Printf(player, "mc_shiftslot <amount>: shift the selected hotbar slot by a specific amount")
		return
	end
	player.steve.persist.hotbarslot = ($ + amount + 9) % 9
end)

-- Toggle whether health persists between levels
CV_RegisterVar({"mc_healthpersist", "Off", CV_NETVAR | CV_CHEAT, CV_OnOff})

-- Toggle whether items persist between levels
CV_RegisterVar({"mc_itempersist", "On", CV_NETVAR | CV_CHEAT, CV_OnOff})

-- Toggle whether items persist after dying
-- * In singleplayer, hotbar contents are restored to their state at the last checkpoint
-- * In multiplayer, hotbar contents are kept exactly the same
CV_RegisterVar({"mc_keepinventory", "On", CV_NETVAR | CV_CHEAT, CV_OnOff})

-- Toggle whether to perform automatic backups upon touching a star post or completing a level
CV_RegisterVar({"mc_dobackups", "On", CV_NETVAR | CV_CHEAT, CV_OnOff})

-- Toggle whether objects should be mined instantly
CV_RegisterVar({"mc_instamine", "Off", CV_NETVAR | CV_CHEAT, CV_OnOff})

-- Toggle whether items should be subtracted from hotbar when placed/tossed
CV_RegisterVar({"mc_itemfreeze", "Off", CV_NETVAR | CV_CHEAT, CV_OnOff})

-- Modify the amount of health that is restored upon touching a star post
CV_RegisterVar({"mc_starpostheal", "6", CV_NETVAR | CV_CHEAT, CV_Unsigned})

-- Modify the change in FOV while sprinting
CV_RegisterVar({"mc_sprintfov", "9", 0, CV_Unsigned})